/***************************************************************************
 *   Borsch interpreter                                                    *
 *   Copyright (C) 2006 Michal Turek                                       *
 *   http://woq.nipax.cz/                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; version 2 of the License   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "cnodevariable.hpp"

#include "ccontext.hpp"


namespace borsch
{

/////////////////////////////////////////////////////////////////////////////
//// Constructor

CNodeVariable::CNodeVariable(const string& name, const string& file, int line)
	:
	CNode(file, line),
	m_name(name)
{

}


/////////////////////////////////////////////////////////////////////////////
//// Destructor

CNodeVariable::~CNodeVariable(void)
{

}


/////////////////////////////////////////////////////////////////////////////
//// Execute()

CNodeValue CNodeVariable::Execute(void)
{
	return CContext::Instance().GetLocalVariable(m_name);
}


/////////////////////////////////////////////////////////////////////////////
//// Dump()

void CNodeVariable::Dump(ostream& os, int indent) const
{
	DumpIndent(os, indent);
	os << "<Variable name=\"" << m_name << "\"/>" << endl;
}


/////////////////////////////////////////////////////////////////////////////
//// operator<<

ostream& operator<<(ostream& os, const CNodeVariable& node)
{
	node.Dump(os);
	return os;
}

}// namespace
